import _extends from "@babel/runtime/helpers/extends";
import React, { useEffect, useState, useRef } from 'react';
import Engine from '@aomao/engine';
import Image, { ImageComponent } from '@aomao/plugin-image';
import Bold from '@aomao/plugin-bold';
import Toolbar, { ToolbarPlugin, ToolbarComponent } from '@aomao/toolbar';
import Alignment from '@aomao/plugin-alignment';
import Backcolor from '@aomao/plugin-backcolor';
import Fontcolor from '@aomao/plugin-fontcolor';
import Fontsize from '@aomao/plugin-fontsize';
import Heading from '@aomao/plugin-heading';
import Hr, { HrComponent } from '@aomao/plugin-hr';
import Indent from '@aomao/plugin-indent';
import Italic from '@aomao/plugin-italic';
import Link from '@aomao/plugin-link';
import Lineheight from '@aomao/plugin-line-height';
import Paintformat from '@aomao/plugin-paintformat';
import Table, { TableComponent } from '@aomao/plugin-table';
import Quote from '@aomao/plugin-quote';
import Redo from '@aomao/plugin-redo';
import Undo from '@aomao/plugin-undo';
import CustomizeImageUploader from './customizeImageUploader'; // import { YeditorContainerStyle } from './styles';

var YEditorEdit = function YEditorEdit(props) {
  var _pluginConfig;

  var _props$height = props.height,
      height = _props$height === void 0 ? 180 : _props$height,
      _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? '' : _props$defaultValue,
      _props$isImageUpdate = props.isImageUpdate,
      isImageUpdate = _props$isImageUpdate === void 0 ? true : _props$isImageUpdate,
      _props$toolConfigs = props.toolConfigs,
      toolConfigs = _props$toolConfigs === void 0 ? [[{
    type: 'collapse',
    groups: [{
      items: ["" + (isImageUpdate ? 'image-uploader' : ''), 'table']
    }]
  }], ['undo', 'redo'], ['indent', 'heading', 'fontsize', 'lineheight', 'fontcolor', 'backcolor', 'bold', 'italic'], ['alignment'], ['hr', 'link'], ['paintformat', 'quote']] : _props$toolConfigs,
      _props$isEditMode = props.isEditMode,
      isEditMode = _props$isEditMode === void 0 ? false : _props$isEditMode,
      placeholder = props.placeholder,
      backgroundColor = props.backgroundColor,
      onChange = props.onChange; // const [editor, setEditor] = useState({
  //   kind: 'editor',
  // });
  // const { pathname } = useLocation();
  // oss 图片配置信息

  var _useState = useState({}),
      editerUpdateImageConfig = _useState[0]; // 编辑器容器


  var view = useRef();
  var ref = useRef(null); // 引擎实例

  var _useState2 = useState(),
      engine = _useState2[0],
      setEngine = _useState2[1]; // 编辑器内容


  var _useState3 = useState(''),
      content = _useState3[0],
      setContent = _useState3[1];

  var imageUploaderOptions = {
    file: {
      name: 'file'
    },
    remote: {
      action: ''
    }
  };
  var pluginConfig = (_pluginConfig = {}, _pluginConfig[CustomizeImageUploader.pluginName] = imageUploaderOptions, _pluginConfig);
  useEffect(function () {
    if (defaultValue) {
      setContent(defaultValue);
    }

    if (!ref.current) return;
    engine && engine.destroy(); // 实例化引擎

    var engines = new Engine(ref.current, {
      className: 'editor-main-container',
      plugins: [Bold, ToolbarPlugin, Image, Alignment, Backcolor, CustomizeImageUploader, Fontcolor, Fontsize, Heading, Hr, Indent, Italic, Link, Lineheight, Paintformat, Quote, Table, Undo, Redo],
      cards: [ToolbarComponent, ImageComponent, HrComponent, TableComponent],
      config: _extends({}, pluginConfig),
      placeholder: placeholder || ''
    }); // 设置编辑器值

    engines.setValue(defaultValue); // 监听编辑器值改变事件

    engines.on('change', function () {
      var value = engines.getValue();
      setContent(value);
      onChange && onChange(value);
    }); // 设置引擎实例

    setEngine(engines);
  }, [editerUpdateImageConfig]);
  return (
    /*#__PURE__*/
    // <YeditorContainerStyle isEdit={isEditMode} height={height} backgroundColor={backgroundColor}>
    // </YeditorContainerStyle>
    React.createElement("div", null, engine && /*#__PURE__*/React.createElement(Toolbar, {
      engine: engine,
      items: toolConfigs
    }), /*#__PURE__*/React.createElement("div", {
      className: "editor-content",
      ref: ref
    }))
  );
};

export default YEditorEdit;