import { useEffect, useState, useRef } from 'react';
import { View } from '@aomao/engine';
import Image, { ImageComponent } from '@aomao/plugin-image';
import Bold from '@aomao/plugin-bold';
import { ToolbarPlugin, ToolbarComponent } from '@aomao/toolbar';
import Alignment from '@aomao/plugin-alignment';
import Backcolor from '@aomao/plugin-backcolor';
import Fontcolor from '@aomao/plugin-fontcolor';
import Fontsize from '@aomao/plugin-fontsize';
import Heading from '@aomao/plugin-heading';
import Hr, { HrComponent } from '@aomao/plugin-hr';
import Indent from '@aomao/plugin-indent';
import Italic from '@aomao/plugin-italic';
import Link from '@aomao/plugin-link';
import Lineheight from '@aomao/plugin-line-height';
import Paintformat from '@aomao/plugin-paintformat';
import Table, { TableComponent } from '@aomao/plugin-table';
import Quote from '@aomao/plugin-quote';
import Redo from '@aomao/plugin-redo';
import Undo from '@aomao/plugin-undo'; // import { YeditorContainerStyle } from './styles';

var YEditorView = function YEditorView(props) {
  var _props$height = props.height,
      height = _props$height === void 0 ? 180 : _props$height,
      _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? '' : _props$defaultValue,
      _props$toolConfigs = props.toolConfigs,
      toolConfigs = _props$toolConfigs === void 0 ? [] : _props$toolConfigs,
      _props$isImageUpdate = props.isImageUpdate,
      isImageUpdate = _props$isImageUpdate === void 0 ? true : _props$isImageUpdate,
      _props$isEditMode = props.isEditMode,
      isEditMode = _props$isEditMode === void 0 ? false : _props$isEditMode,
      onChange = props.onChange,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? '' : _props$placeholder,
      backgroundColor = props.backgroundColor; // const [editor, setEditor] = useState({
  //   kind: 'editor',
  // });
  // const { pathname } = useLocation();
  // 编辑器容器

  var view = useRef();
  var ref = useRef(null); // 引擎实例
  // 编辑器内容

  var _useState = useState(''),
      content = _useState[0],
      setContent = _useState[1];

  useEffect(function () {
    if (defaultValue) {
      setContent(defaultValue);
    }
  }, []);
  useEffect(function () {
    if (!ref.current) return;
    view.current = new View(ref.current, {
      plugins: [Bold, ToolbarPlugin, Image, Alignment, Backcolor, Fontcolor, Fontsize, Heading, Hr, Indent, Italic, Link, Lineheight, Paintformat, Quote, Table, Undo, Redo],
      cards: [ToolbarComponent, ImageComponent, HrComponent, TableComponent]
    }); // 渲染内容到viewRef节点下

    view.current.render(content);
  }, [content]);
  return (
    /*#__PURE__*/
    // <YeditorContainerStyle isEdit={isEditMode} height={height} backgroundColor={backgroundColor}>
    //   {/* {
    //     engine && (
    //       <Toolbar
    //         engine={engine}
    //         items={toolConfigs}
    //       />
    //     )
    //   } */}
    //   <div
    //     className="editor-content"
    //     ref={ref}
    //   />
    // </YeditorContainerStyle>
    React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: "editor-content",
      ref: ref
    }))
  );
};

export default YEditorView;