import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import * as React from 'react';
import { useEffect, useState } from 'react';
import moment from 'moment';
import YEditorView from './components/editMode/edit';
import YEditorEdit from './components/viewMode/view';
import './index.css';
export default function YwEditor(props) {
  var _props$isEditMode = props.isEditMode,
      isEditMode = _props$isEditMode === void 0 ? false : _props$isEditMode,
      ossConfig = props.ossConfig;

  var _useState = useState(false),
      isEdit = _useState[0],
      setIsEdit = _useState[1];

  var _useState2 = useState(''),
      editorkey = _useState2[0],
      setEditorkey = _useState2[1]; // oss start


  var getOSSDataAPI = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var date, dateFile, env, projectId, domain, typeFile, dir;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              date = new Date();
              dateFile = date.getFullYear() + "/" + (date.getMonth() + 1) + "/" + date.getDate() + "/";
              env = ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.env) || ''; // PROSUPPLIER FOUNDATION

              projectId = ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.projectId) || 'FOUNDATION';
              domain = (env && env !== 'prod' && env !== 'production' ? env + "-" : '') + "generic-api.ywwl.com";
              typeFile = 'image-cdn';
              dir = projectId + "/project/base" + moment().format('/YYYY/MM') + "/" + typeFile + "/" + dateFile; // public
              // eslint-disable-next-line @iceworks/best-practices/recommend-polyfill

              localStorage.setItem('yEditorOssConfigs', JSON.stringify({
                env: env,
                projectId: projectId,
                domain: domain,
                typeFile: typeFile,
                dir: dir,
                tokenKey: ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.tokenKey) || 'token'
              }));

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function getOSSDataAPI() {
      return _ref.apply(this, arguments);
    };
  }();

  useEffect(function () {
    getOSSDataAPI();
  }, []);
  useEffect(function () {
    setIsEdit(isEditMode);
    setEditorkey("edit-timetamp-" + new Date().getTime());
  }, [isEditMode]);
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(React.Fragment, null, isEdit ? /*#__PURE__*/React.createElement(YEditorEdit, _extends({}, props, {
    key: editorkey
  })) : /*#__PURE__*/React.createElement(YEditorView, _extends({}, props, {
    key: editorkey
  }))));
} // export { default as YwEditor } from './components/YwEditor';
// export type { YwEditorProps } from './components/YwEditor';