/// <reference types="react" />
import '@wangeditor/editor/dist/css/style.css';
import './index.css';
export interface YwEditorProps {
    /** 编辑器高度 */
    height?: number | string;
    /** 默认值 */
    defaultValue?: string;
    /** 工具栏配置 */
    toolConfigs?: any[];
    isEditMode?: boolean;
    onChange?: any;
    onBlur?: () => void;
    onFocus?: () => void;
    placeholder?: string;
    ossConfig?: {
        env?: string;
        projectId?: string;
        tokenKey?: string;
    };
    isInitNull?: boolean;
    /** 上传图片配置 */
    uploadImageConfig?: IUploadImageConfig;
    /** 上传附件配置 */
    uploadAttachmentConfig?: IUploadAttachmentConfig;
}
export interface IUploadImageConfig {
    /** 单个文件的最大体积限制，默认为 10M */
    maxFileSize: number;
    /** 最多可上传几个文件，默认为 10 */
    maxNumberOfFiles: number;
    /** 选择文件时的类型限制，默认为 ['image/*'] 。如不想限制，则设置为 [] */
    allowedFileTypes: string[];
}
export interface IUploadAttachmentConfig {
    /** 单个文件的最大体积限制，默认为 10M */
    maxFileSize: number;
    /** 最多可上传几个文件，默认为 10 */
    maxNumberOfFiles: number;
    /** 选择文件时的类型限制，默认为 [] 不限制类型 */
    allowedFileTypes: string[];
    onUpload?: (file: File) => void;
    onProgress: (progress: number) => void;
    onSuccess: (file: File, res: any) => void;
    onFailed: (file: File, res: any) => void;
    onError?: (file: File, msg: string, res: any) => void;
}
export default function YwEditor(props: YwEditorProps): JSX.Element;
