"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _engine = _interopRequireDefault(require("@aomao/engine"));

var _pluginImage = _interopRequireWildcard(require("@aomao/plugin-image"));

var _pluginBold = _interopRequireDefault(require("@aomao/plugin-bold"));

var _toolbar = _interopRequireWildcard(require("@aomao/toolbar"));

var _pluginAlignment = _interopRequireDefault(require("@aomao/plugin-alignment"));

var _pluginBackcolor = _interopRequireDefault(require("@aomao/plugin-backcolor"));

var _pluginFontcolor = _interopRequireDefault(require("@aomao/plugin-fontcolor"));

var _pluginFontsize = _interopRequireDefault(require("@aomao/plugin-fontsize"));

var _pluginHeading = _interopRequireDefault(require("@aomao/plugin-heading"));

var _pluginHr = _interopRequireWildcard(require("@aomao/plugin-hr"));

var _pluginIndent = _interopRequireDefault(require("@aomao/plugin-indent"));

var _pluginItalic = _interopRequireDefault(require("@aomao/plugin-italic"));

var _pluginLink = _interopRequireDefault(require("@aomao/plugin-link"));

var _pluginLineHeight = _interopRequireDefault(require("@aomao/plugin-line-height"));

var _pluginPaintformat = _interopRequireDefault(require("@aomao/plugin-paintformat"));

var _pluginTable = _interopRequireWildcard(require("@aomao/plugin-table"));

var _pluginQuote = _interopRequireDefault(require("@aomao/plugin-quote"));

var _pluginRedo = _interopRequireDefault(require("@aomao/plugin-redo"));

var _pluginUndo = _interopRequireDefault(require("@aomao/plugin-undo"));

var _customizeImageUploader = _interopRequireDefault(require("./customizeImageUploader"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var YEditorEdit = function YEditorEdit(props) {
  var _pluginConfig;

  var _props$height = props.height,
      height = _props$height === void 0 ? 180 : _props$height,
      _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? '' : _props$defaultValue,
      _props$isImageUpdate = props.isImageUpdate,
      isImageUpdate = _props$isImageUpdate === void 0 ? true : _props$isImageUpdate,
      _props$toolConfigs = props.toolConfigs,
      toolConfigs = _props$toolConfigs === void 0 ? [[{
    type: 'collapse',
    groups: [{
      items: ["" + (isImageUpdate ? 'image-uploader' : ''), 'table']
    }]
  }], ['undo', 'redo'], ['indent', 'heading', 'fontsize', 'lineheight', 'fontcolor', 'backcolor', 'bold', 'italic'], ['alignment'], ['hr', 'link'], ['paintformat', 'quote']] : _props$toolConfigs,
      _props$isEditMode = props.isEditMode,
      isEditMode = _props$isEditMode === void 0 ? false : _props$isEditMode,
      placeholder = props.placeholder,
      backgroundColor = props.backgroundColor,
      onChange = props.onChange; // const [editor, setEditor] = useState({
  //   kind: 'editor',
  // });
  // const { pathname } = useLocation();
  // oss 图片配置信息

  var _useState = (0, _react.useState)({}),
      editerUpdateImageConfig = _useState[0]; // 编辑器容器


  var view = (0, _react.useRef)();
  var ref = (0, _react.useRef)(null); // 引擎实例

  var _useState2 = (0, _react.useState)(),
      engine = _useState2[0],
      setEngine = _useState2[1]; // 编辑器内容


  var _useState3 = (0, _react.useState)(''),
      content = _useState3[0],
      setContent = _useState3[1];

  var imageUploaderOptions = {
    file: {
      name: 'file'
    },
    remote: {
      action: ''
    }
  };
  var pluginConfig = (_pluginConfig = {}, _pluginConfig[_customizeImageUploader["default"].pluginName] = imageUploaderOptions, _pluginConfig);
  (0, _react.useEffect)(function () {
    if (defaultValue) {
      setContent(defaultValue);
    }

    if (!ref.current) return;
    engine && engine.destroy(); // 实例化引擎

    var engines = new _engine["default"](ref.current, {
      className: 'editor-main-container',
      plugins: [_pluginBold["default"], _toolbar.ToolbarPlugin, _pluginImage["default"], _pluginAlignment["default"], _pluginBackcolor["default"], _customizeImageUploader["default"], _pluginFontcolor["default"], _pluginFontsize["default"], _pluginHeading["default"], _pluginHr["default"], _pluginIndent["default"], _pluginItalic["default"], _pluginLink["default"], _pluginLineHeight["default"], _pluginPaintformat["default"], _pluginQuote["default"], _pluginTable["default"], _pluginUndo["default"], _pluginRedo["default"]],
      cards: [_toolbar.ToolbarComponent, _pluginImage.ImageComponent, _pluginHr.HrComponent, _pluginTable.TableComponent],
      config: (0, _extends2["default"])({}, pluginConfig),
      placeholder: placeholder || ''
    }); // 设置编辑器值

    engines.setValue(defaultValue); // 监听编辑器值改变事件

    engines.on('change', function () {
      var value = engines.getValue();
      setContent(value);
      onChange && onChange(value);
    }); // 设置引擎实例

    setEngine(engines);
  }, [editerUpdateImageConfig]);
  return (
    /*#__PURE__*/
    // <YeditorContainerStyle isEdit={isEditMode} height={height} backgroundColor={backgroundColor}>
    // </YeditorContainerStyle>
    _react["default"].createElement("div", null, engine && /*#__PURE__*/_react["default"].createElement(_toolbar["default"], {
      engine: engine,
      items: toolConfigs
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "editor-content",
      ref: ref
    }))
  );
};

var _default = YEditorEdit;
exports["default"] = _default;