"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _react = require("react");

var _engine = require("@aomao/engine");

var _pluginImage = _interopRequireWildcard(require("@aomao/plugin-image"));

var _pluginBold = _interopRequireDefault(require("@aomao/plugin-bold"));

var _toolbar = require("@aomao/toolbar");

var _pluginAlignment = _interopRequireDefault(require("@aomao/plugin-alignment"));

var _pluginBackcolor = _interopRequireDefault(require("@aomao/plugin-backcolor"));

var _pluginFontcolor = _interopRequireDefault(require("@aomao/plugin-fontcolor"));

var _pluginFontsize = _interopRequireDefault(require("@aomao/plugin-fontsize"));

var _pluginHeading = _interopRequireDefault(require("@aomao/plugin-heading"));

var _pluginHr = _interopRequireWildcard(require("@aomao/plugin-hr"));

var _pluginIndent = _interopRequireDefault(require("@aomao/plugin-indent"));

var _pluginItalic = _interopRequireDefault(require("@aomao/plugin-italic"));

var _pluginLink = _interopRequireDefault(require("@aomao/plugin-link"));

var _pluginLineHeight = _interopRequireDefault(require("@aomao/plugin-line-height"));

var _pluginPaintformat = _interopRequireDefault(require("@aomao/plugin-paintformat"));

var _pluginTable = _interopRequireWildcard(require("@aomao/plugin-table"));

var _pluginQuote = _interopRequireDefault(require("@aomao/plugin-quote"));

var _pluginRedo = _interopRequireDefault(require("@aomao/plugin-redo"));

var _pluginUndo = _interopRequireDefault(require("@aomao/plugin-undo"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var YEditorView = function YEditorView(props) {
  var _props$height = props.height,
      height = _props$height === void 0 ? 180 : _props$height,
      _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? '' : _props$defaultValue,
      _props$toolConfigs = props.toolConfigs,
      toolConfigs = _props$toolConfigs === void 0 ? [] : _props$toolConfigs,
      _props$isImageUpdate = props.isImageUpdate,
      isImageUpdate = _props$isImageUpdate === void 0 ? true : _props$isImageUpdate,
      _props$isEditMode = props.isEditMode,
      isEditMode = _props$isEditMode === void 0 ? false : _props$isEditMode,
      onChange = props.onChange,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? '' : _props$placeholder,
      backgroundColor = props.backgroundColor; // const [editor, setEditor] = useState({
  //   kind: 'editor',
  // });
  // const { pathname } = useLocation();
  // 编辑器容器

  var view = (0, _react.useRef)();
  var ref = (0, _react.useRef)(null); // 引擎实例
  // 编辑器内容

  var _useState = (0, _react.useState)(''),
      content = _useState[0],
      setContent = _useState[1];

  (0, _react.useEffect)(function () {
    if (defaultValue) {
      setContent(defaultValue);
    }
  }, []);
  (0, _react.useEffect)(function () {
    if (!ref.current) return;
    view.current = new _engine.View(ref.current, {
      plugins: [_pluginBold["default"], _toolbar.ToolbarPlugin, _pluginImage["default"], _pluginAlignment["default"], _pluginBackcolor["default"], _pluginFontcolor["default"], _pluginFontsize["default"], _pluginHeading["default"], _pluginHr["default"], _pluginIndent["default"], _pluginItalic["default"], _pluginLink["default"], _pluginLineHeight["default"], _pluginPaintformat["default"], _pluginQuote["default"], _pluginTable["default"], _pluginUndo["default"], _pluginRedo["default"]],
      cards: [_toolbar.ToolbarComponent, _pluginImage.ImageComponent, _pluginHr.HrComponent, _pluginTable.TableComponent]
    }); // 渲染内容到viewRef节点下

    view.current.render(content);
  }, [content]);
  return (
    /*#__PURE__*/
    // <YeditorContainerStyle isEdit={isEditMode} height={height} backgroundColor={backgroundColor}>
    //   {/* {
    //     engine && (
    //       <Toolbar
    //         engine={engine}
    //         items={toolConfigs}
    //       />
    //     )
    //   } */}
    //   <div
    //     className="editor-content"
    //     ref={ref}
    //   />
    // </YeditorContainerStyle>
    React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: "editor-content",
      ref: ref
    }))
  );
};

var _default = YEditorView;
exports["default"] = _default;