"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = YwEditor;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var React = _interopRequireWildcard(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _edit = _interopRequireDefault(require("./components/editMode/edit"));

var _view = _interopRequireDefault(require("./components/viewMode/view"));

require("./index.css");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function YwEditor(props) {
  var _props$isEditMode = props.isEditMode,
      isEditMode = _props$isEditMode === void 0 ? false : _props$isEditMode,
      ossConfig = props.ossConfig;

  var _useState = (0, React.useState)(false),
      isEdit = _useState[0],
      setIsEdit = _useState[1];

  var _useState2 = (0, React.useState)(''),
      editorkey = _useState2[0],
      setEditorkey = _useState2[1]; // oss start


  var getOSSDataAPI = /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var date, dateFile, env, projectId, domain, typeFile, dir;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              date = new Date();
              dateFile = date.getFullYear() + "/" + (date.getMonth() + 1) + "/" + date.getDate() + "/";
              env = ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.env) || ''; // PROSUPPLIER FOUNDATION

              projectId = ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.projectId) || 'FOUNDATION';
              domain = (env && env !== 'prod' && env !== 'production' ? env + "-" : '') + "generic-api.ywwl.com";
              typeFile = 'image-cdn';
              dir = projectId + "/project/base" + (0, _moment["default"])().format('/YYYY/MM') + "/" + typeFile + "/" + dateFile; // public
              // eslint-disable-next-line @iceworks/best-practices/recommend-polyfill

              localStorage.setItem('yEditorOssConfigs', JSON.stringify({
                env: env,
                projectId: projectId,
                domain: domain,
                typeFile: typeFile,
                dir: dir,
                tokenKey: ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.tokenKey) || 'token'
              }));

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function getOSSDataAPI() {
      return _ref.apply(this, arguments);
    };
  }();

  (0, React.useEffect)(function () {
    getOSSDataAPI();
  }, []);
  (0, React.useEffect)(function () {
    setIsEdit(isEditMode);
    setEditorkey("edit-timetamp-" + new Date().getTime());
  }, [isEditMode]);
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(React.Fragment, null, isEdit ? /*#__PURE__*/React.createElement(_view["default"], (0, _extends2["default"])({}, props, {
    key: editorkey
  })) : /*#__PURE__*/React.createElement(_edit["default"], (0, _extends2["default"])({}, props, {
    key: editorkey
  }))));
} // export { default as YwEditor } from './components/YwEditor';
// export type { YwEditorProps } from './components/YwEditor';