"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = YwEditor;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var React = _interopRequireWildcard(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _uuid = require("uuid");

var _editorForReact = require("@wangeditor/editor-for-react");

var _editor = require("@wangeditor/editor");

var _pluginUploadAttachment = _interopRequireDefault(require("@wangeditor/plugin-upload-attachment"));

require("@wangeditor/editor/dist/css/style.css");

require("./index.css");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// 引入 css

/** 上传图片默认配置 */
var defUploadImageConfig = {
  maxFileSize: 10 * 1024 * 1024,
  // 10M
  maxNumberOfFiles: 10,
  // 最多可上传几个文件，默认为 10
  allowedFileTypes: ['image/*'] // 选择文件时的类型限制，默认为 ['image/*'] 。如不想限制，则设置为 []

};
/** 上传附件默认配置 */

var defUploadAttachmentConfig = {
  maxFileSize: 10 * 1024 * 1024,
  // 10M
  maxNumberOfFiles: 10,
  // 最多可上传几个文件，默认为 10
  allowedFileTypes: [],
  // 选择文件时的类型限制，默认为 [] 不限制类型 。
  onUpload: function onUpload(file) {},
  onProgress: function onProgress(progress) {},
  onSuccess: function onSuccess(file, res) {},
  onFailed: function onFailed(file, res) {},
  onError: function onError(file, msg, res) {}
}; // 注册上传附件功能。创建编辑器之前注册，且只能注册一次，不可重复注册。

_editor.Boot.registerModule(_pluginUploadAttachment["default"]);

var YEditorConfigs = {};

function YwEditor(props) {
  var _props$height = props.height,
      height = _props$height === void 0 ? '250px' : _props$height,
      _props$isEditMode = props.isEditMode,
      isEditMode = _props$isEditMode === void 0 ? true : _props$isEditMode,
      ossConfig = props.ossConfig,
      defaultValue = props.defaultValue,
      placeholder = props.placeholder,
      _onChange = props.onChange,
      onBlur = props.onBlur,
      onFocus = props.onFocus,
      toolConfigs = props.toolConfigs,
      _props$isInitNull = props.isInitNull,
      isInitNull = _props$isInitNull === void 0 ? false : _props$isInitNull,
      _props$uploadImageCon = props.uploadImageConfig,
      uploadImageConfig = _props$uploadImageCon === void 0 ? defUploadImageConfig : _props$uploadImageCon,
      _props$uploadAttachme = props.uploadAttachmentConfig,
      uploadAttachmentConfig = _props$uploadAttachme === void 0 ? defUploadAttachmentConfig : _props$uploadAttachme; // 编辑器内容
  // editor 实例

  var _useState = (0, React.useState)(null),
      editor = _useState[0],
      setEditor = _useState[1]; // 编辑器内容


  var _useState2 = (0, React.useState)(''),
      html = _useState2[0],
      setHtml = _useState2[1];

  var _useState3 = (0, React.useState)(false),
      isEdit = _useState3[0],
      setIsEdit = _useState3[1];

  var _useState4 = (0, React.useState)(''),
      editorkey = _useState4[0],
      setEditorkey = _useState4[1];
  /** 工具栏配置 */


  var toolbarConfig = {};

  if (toolConfigs && toolConfigs.length) {
    toolbarConfig.toolbarKeys = toolConfigs;
  }

  toolbarConfig.excludeKeys = ['insertImage', 'insertVideo'];
  /** 编辑器配置 */

  var editorConfig = {
    placeholder: placeholder,
    MENU_CONF: {},
    // 在编辑器中，点击选中“附件”节点时，要弹出的菜单
    hoverbarKeys: {
      attachment: {
        menuKeys: ['downloadAttachment'] // “下载附件”菜单

      }
    }
  }; // 图片上传配置

  editorConfig.MENU_CONF['uploadImage'] = (0, _extends2["default"])({
    // form-data fieldName ，默认值 'wangeditor-uploaded-image'
    fieldName: 'your-custom-name',
    // 单个文件的最大体积限制，默认为 2M
    maxFileSize: 1 * 1024 * 1024,
    // 1M
    // 最多可上传几个文件，默认为 100
    maxNumberOfFiles: 10,
    // 选择文件时的类型限制，默认为 ['image/*'] 。如不想限制，则设置为 []
    allowedFileTypes: ['image/*'],
    // 自定义上传参数，例如传递验证的 token 等。参数会被添加到 formData 中，一起上传到服务端。
    // meta: {
    //   token: 'xxx',
    //   otherKey: 'yyy',
    // },
    // 将 meta 拼接到 url 参数中，默认 false
    metaWithUrl: false,
    // 自定义增加 http  header
    // headers: {
    //   Accept: 'text/x-json',
    //   otherKey: 'xxx',
    // },
    // 跨域是否传递 cookie ，默认为 false
    withCredentials: true,
    // 超时时间，默认为 10 秒
    timeout: 5 * 1000,
    // 5 秒
    server: '/api/upload'
  }, uploadImageConfig, {
    // 自定义上传
    customUpload: function customUpload(file, insertFn) {
      return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var date, dateFile, env, projectId, domain, typeFile, dir;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // TS 语法
                // file 即选中的文件
                // 自己实现上传，并得到图片 url alt href
                // 最后插入图片
                date = new Date();
                dateFile = date.getFullYear() + "/" + (date.getMonth() + 1) + "/" + date.getDate() + "/";
                env = ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.env) || ''; // PROSUPPLIER FOUNDATION

                projectId = ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.projectId) || 'FOUNDATION';
                domain = (env && env !== 'prod' && env !== 'production' ? env + "-" : '') + "generic-api.ywwl.com";
                typeFile = 'image-cdn';
                dir = projectId + "/project/base" + (0, _moment["default"])().format('/YYYY/MM') + "/" + typeFile + "/" + dateFile; // public

                YEditorConfigs = {
                  env: env,
                  projectId: projectId,
                  domain: domain,
                  typeFile: typeFile,
                  dir: dir,
                  tokenKey: ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.tokenKey) || 'token'
                }; // eslint-disable-next-line @iceworks/best-practices/recommend-polyfill

                fetch("https://" + YEditorConfigs.domain + "/oss/getSignatureInfo?projectId=" + YEditorConfigs.projectId + "&dir=" + YEditorConfigs.dir + "&securityType=public", {
                  method: 'GET'
                }).then(function (res) {
                  // 处理http响应
                  res.json().then(function (resData) {
                    var results = resData && resData.data;

                    if (results && results.signature) {
                      YEditorConfigs = (0, _extends2["default"])({}, YEditorConfigs, results);
                      var result = (0, _extends2["default"])({}, YEditorConfigs);
                      var fileForm = new FormData();
                      var imageType = file.type.split('/')[1];
                      fileForm.append('key', "" + (result === null || result === void 0 ? void 0 : result.dir) + (0, _uuid.v4)() + "." + imageType);
                      fileForm.append('policy', result.policy || '');
                      fileForm.append('OSSAccessKeyId', (result === null || result === void 0 ? void 0 : result.accessId) || '');
                      fileForm.append('success_action_status', '201');
                      fileForm.append('signature', (result === null || result === void 0 ? void 0 : result.signature) || '');
                      fileForm.append('file', file);
                      var httpRequest = new XMLHttpRequest();
                      httpRequest.open('POST', result.host || ''); // httpRequest.setRequestHeader('Content-type', 'multipart/form-data');

                      httpRequest.setRequestHeader('X-TOKEN', result.tokenKey ? localStorage.getItem(result.tokenKey) : '');
                      httpRequest.send(fileForm); // 发送请求 将json写入send中

                      httpRequest.onreadystatechange = function () {
                        if (httpRequest.readyState === 4) {
                          if (httpRequest.status === 200 || httpRequest.status === 201) {
                            var json = httpRequest.responseText; // 获取到服务端返回的数据
                            // eslint-disable-next-line max-len

                            insertFn(json.split('<Location>')[1].split('</Location>')[0], json.split('<Location>')[1].split('</Location>')[0], json.split('<Location>')[1].split('</Location>')[0]);
                          }
                        }
                      };
                    }
                  })["catch"](function () {
                    return false;
                  });
                }, function () {
                  // 处理错误
                  return false;
                });

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    // 上传之前触发
    onBeforeUpload: function onBeforeUpload(file) {},
    // 上传进度的回调函数
    onProgress: function onProgress(progress) {
      // TS 语法
      // onProgress(progress) {       // JS 语法
      // progress 是 0-100 的数字
      console.log('progress', progress);
    },
    // 单个文件上传成功之后
    onSuccess: function onSuccess(file, res) {
      // TS 语法
      // onSuccess(file, res) {          // JS 语法
      console.log(file.name + " \u4E0A\u4F20\u6210\u529F", res);
    },
    // 单个文件上传失败
    onFailed: function onFailed(file, res) {
      // TS 语法
      // onFailed(file, res) {           // JS 语法
      console.log(file.name + " \u4E0A\u4F20\u5931\u8D25", res);
    },
    // 上传错误，或者触发 timeout 超时
    onError: function onError(file, err, res) {
      // TS 语法
      // onError(file, err, res) {               // JS 语法
      console.log(file.name + " \u4E0A\u4F20\u51FA\u9519", err, res);
    }
  }); // 上传附件 菜单配置

  editorConfig.MENU_CONF['uploadAttachment'] = {
    server: '/api/upload',
    // 服务端地址
    timeout: 5 * 1000,
    // 5s
    fieldName: 'custom-fileName',
    meta: {},
    // 请求时附加的数据
    metaWithUrl: false,
    // meta 拼接到 url 上
    // headers: { Accept: 'text/x-json' },
    maxFileSize: 10 * 1024 * 1024,
    // 10M
    // 上传之前
    onBeforeUpload: function onBeforeUpload(file) {
      return file; // 上传 file 文件
      // return false // 会阻止上传
    },
    onProgress: function onProgress(progress) {
      console.log('onProgress', progress);
    },
    onSuccess: function onSuccess(file, res) {
      console.log('onSuccess', file, res);
    },
    onFailed: function onFailed(file, res) {
      alert(res.message);
      console.log('onFailed', file, res);
    },
    onError: function onError(file, err, res) {
      alert(err.message);
      console.error('onError', file, err, res);
    },
    // // 上传成功后，用户自定义插入文件
    // customInsert(res: any, file: File, insertFn: Function) {
    //   console.log('customInsert', res)
    //   const { url } = res.data || {}
    //   if (!url) throw new Error(`url is empty`)
    //   // 插入附件到编辑器
    //   insertFn(`customInsert-${file.name}`, url)
    // },
    // 自定义上传方法
    customUpload: function customUpload(file, insertFn) {
      // 文件扩展名
      var fileExt = file.name.split('.').pop();

      if (uploadAttachmentConfig.allowedFileTypes.length > 0 && !uploadAttachmentConfig.allowedFileTypes.includes(fileExt)) {
        uploadAttachmentConfig.onError && uploadAttachmentConfig.onError(file, '文件类型不支持', {});
        return false;
      }

      if (file.size > uploadAttachmentConfig.maxFileSize) {
        uploadAttachmentConfig.onError && uploadAttachmentConfig.onError(file, '文件大小超过限制', {});
        return false;
      } // file 即选中的文件
      // 自己实现上传，并得到 url


      var date = new Date();
      var dateFile = date.getFullYear() + "/" + (date.getMonth() + 1) + "/" + date.getDate() + "/";
      var env = ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.env) || ''; // PROSUPPLIER FOUNDATION

      var projectId = ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.projectId) || 'FOUNDATION';
      var domain = (env && env !== 'prod' && env !== 'production' ? env + "-" : '') + "generic-api.ywwl.com";
      var typeFile = 'attachment-cdn';
      var dir = projectId + "/project/base" + (0, _moment["default"])().format('/YYYY/MM') + "/" + typeFile + "/" + dateFile; // public

      YEditorConfigs = {
        env: env,
        projectId: projectId,
        domain: domain,
        typeFile: typeFile,
        dir: dir,
        tokenKey: ossConfig && (ossConfig === null || ossConfig === void 0 ? void 0 : ossConfig.tokenKey) || 'token'
      }; // eslint-disable-next-line @iceworks/best-practices/recommend-polyfill

      var fetchUrl = "https://" + YEditorConfigs.domain + "/oss/getSignatureInfo?projectId=" + YEditorConfigs.projectId + "&dir=" + YEditorConfigs.dir + "&securityType=public";
      uploadAttachmentConfig.onUpload && uploadAttachmentConfig.onUpload(file);
      fetch(fetchUrl, {
        method: 'GET'
      }).then(function (res) {
        // 处理http响应
        res.json().then(function (resData) {
          var results = resData && resData.data;

          if (results && results.signature) {
            YEditorConfigs = (0, _extends2["default"])({}, YEditorConfigs, results);
            var result = (0, _extends2["default"])({}, YEditorConfigs);
            var fileForm = new FormData();
            fileForm.append('key', "" + (result === null || result === void 0 ? void 0 : result.dir) + (0, _uuid.v4)() + "_" + file.name);
            fileForm.append('policy', result.policy || '');
            fileForm.append('OSSAccessKeyId', (result === null || result === void 0 ? void 0 : result.accessId) || '');
            fileForm.append('success_action_status', '201');
            fileForm.append('signature', (result === null || result === void 0 ? void 0 : result.signature) || '');
            fileForm.append('file', file);
            var httpRequest = new XMLHttpRequest();
            httpRequest.open('POST', result.host || ''); // httpRequest.setRequestHeader('Content-type', 'multipart/form-data');

            httpRequest.setRequestHeader('X-TOKEN', result.tokenKey ? localStorage.getItem(result.tokenKey) : '');
            httpRequest.send(fileForm); // 发送请求

            httpRequest.onreadystatechange = function () {
              if (httpRequest.readyState === 4) {
                if (httpRequest.status === 200 || httpRequest.status === 201) {
                  var resText = httpRequest.responseText; // 获取到服务端返回的数据

                  var fileName = file.name;
                  var fileUrl = resText.split('<Location>')[1].split('</Location>')[0];
                  insertFn(fileName, fileUrl, fileUrl);
                  uploadAttachmentConfig.onSuccess && uploadAttachmentConfig.onSuccess(file, {
                    fileName: fileName,
                    fileUrl: fileUrl
                  });
                }
              }
            };
          }
        })["catch"](function (err) {
          uploadAttachmentConfig.onFailed && uploadAttachmentConfig.onFailed(file, {
            err: err
          });
          return false;
        });
      }, function (err) {
        // 处理错误
        uploadAttachmentConfig.onFailed && uploadAttachmentConfig.onFailed(file, {
          err: err
        });
        return false;
      });
    } // // 自定义选择
    // customBrowseAndUpload(insertFn: Function) {
    //   alert('自定义选择文件，如弹出图床')
    //   // 自己上传文件
    //   // 上传之后用 insertFn(fileName, link) 插入到编辑器
    // },
    // 插入到编辑器后的回调
    // onInsertedAttachment(elem: AttachmentElement) {
    //   console.log('inserted attachment', elem)
    // },

  };

  editorConfig.onBlur = function () {
    onBlur && onBlur();
  };

  editorConfig.onFocus = function () {
    onFocus && onFocus();
  };

  (0, React.useEffect)(function () {
    setHtml(defaultValue);
  }, [defaultValue]); // 及时销毁 editor ，重要！

  (0, React.useEffect)(function () {
    return function () {
      if (editor == null) return;
      editor.destroy();
      setEditor(null);
    };
  }, [editor]);
  (0, React.useEffect)(function () {
    setIsEdit(isEditMode);
    editorConfig.readOnly = !isEditMode;
    setEditorkey("edit-timetamp-" + new Date().getTime());
  }, [isEditMode]);
  return /*#__PURE__*/React.createElement("div", null, isEdit ? /*#__PURE__*/React.createElement("div", {
    style: {
      border: '1px solid #ccc',
      zIndex: 100
    }
  }, /*#__PURE__*/React.createElement(_editorForReact.Toolbar, {
    editor: editor,
    defaultConfig: toolbarConfig,
    mode: "default",
    style: {
      borderBottom: '1px solid #ccc'
    }
  }), /*#__PURE__*/React.createElement(_editorForReact.Editor, {
    defaultConfig: editorConfig,
    value: html,
    onCreated: setEditor,
    onChange: function onChange(editor) {
      setHtml(editor.getHtml());
      var h = editor.getHtml();

      if (isInitNull) {
        _onChange && _onChange(h === '<p><br></p>' ? '' : h);
      } else {
        _onChange && _onChange(h);
      } // const toolbar = DomEditor.getToolbar(editor);
      // const curToolbarConfig = toolbar.getConfig();
      // console.log(curToolbarConfig.toolbarKeys); // 当前菜单排序和分组

    },
    mode: "default",
    style: {
      height: height,
      overflowY: 'hidden'
    }
  })) : /*#__PURE__*/React.createElement("div", {
    style: {
      marginTop: '15px'
    },
    dangerouslySetInnerHTML: {
      __html: html
    }
  }));
} // export { default as YwEditor } from './components/YwEditor';
// export type { YwEditorProps } from './components/YwEditor';